/*
 *  <Short Description>
 *  Copyright (C) 2024  Brett Terpstra
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BLT_WITH_GRAPHICS_CAMERA_H
#define BLT_WITH_GRAPHICS_CAMERA_H

#include "blt/gfx/state.h"

namespace blt::gfx
{
    
    class first_person_camera
    {
        private:
            blt::vec3 position_;
            blt::vec3 rotation_;
            blt::vec3 speed_ {50, 50, 50};
        public:
            void update();
            
            inline void speed(const blt::vec3& speed)
            {
                speed_ = speed;
            }
            
            [[nodiscard]] inline const vec3& speed() const
            {
                return speed_;
            }
            
            [[nodiscard]] inline const vec3& position() const
            {
                return position_;
            }
            
            void update_view(matrix_state_manager& manager);
    };
    
}

#endif //BLT_WITH_GRAPHICS_CAMERA_H
